System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = initDrives;

var drives;

function convertBytes(b)
{
	var i = 0, u = Array(' MB', ' GB', ' TB');
	
	while (b >= 1024 && (b / 1024) >= 1)
	{
		b /= 1024;
		i++;
	}
	
	return (Math.round(b * 100) / 100) + u[i];
}

function openDrive()
{        
	var d = window.event.srcElement.getAttribute('drive');    
	System.Shell.execute(d + ':\\');
}

function showDrives()
{
	var y = 0;
	canvas.removeObjects();
	
	var show = System.Gadget.Settings.read("show");
	var clr = System.Gadget.Settings.read("colorr");
	
	if (show != "true")
	{
		canvas.addImageObject('images/refresh.png', 110, 0);
	}
		
	var r = document.createElement('DIV');
	r.className = 'target';
	r.style.posLeft = 110;
	r.style.posTop = 0;
	r.style.posHeight = 16;
	r.onclick = initDrives;
	targets.appendChild(r);
	
	for(var i = 0; i < drives.length; i++)
	{
		var d = drives[i];

		if (d)
		{
			canvas.addImageObject('images/background.png', 0, y);
			if (d.isReady) 
			{
				var f = Math.round(d.freeSpace / d.totalSize * 100);
				
				var  u = (100 - f);
				
				var m = canvas.addImageObject('images/meter' + (u < 90 ? 'blue': 'red') + '.png', 5, y + 32);   
				var mwidth = Math.floor((u * 120 / 100));
				if (mwidth < 1)
				{
					mwidth = 1;
				}
				m.width = mwidth;
				m.left = 5 - Math.floor(((120 - m.width) / 2));
				
				canvas.addImageObject('images/drives/drive' + d.driveType + '.png', 0, y);
				canvas.addTextObject(' (' + d.driveLetter + ':)', 'Segoe UI', 11, clr, 40, y + 5);
				canvas.addTextObject(convertBytes(d.totalSize), 'Segoe UI', 10, clr, 60, y + 5);
				canvas.addTextObject(convertBytes(d.freeSpace) + ' / ' + f + '%', 'Segoe UI', 10, clr, 50, y + 17);
				
				var Vlabel = System.Gadget.Settings.read("Vlabel");
				
				if (Vlabel != "true")
				{
					canvas.addTextObject(d.volumeLabel, 'Segoe UI', 10, clr, 40, y + 30);
				}
			
				if (d.driveLetter == 'C') canvas.addImageObject('images/drives/drive7.png', 0, y);
				
				var o = document.createElement('DIV');
				o.className = 'target';
				o.style.posTop = y;
				o.setAttribute('drive', d.driveLetter);
				o.onclick = openDrive;
				targets.appendChild(o);
			}
			else
			{            
				canvas.addImageObject('images/drives/drive' + d.driveType + '.png', 0, y);
				canvas.addImageObject('images/notready.png', 5, y + 29);
				canvas.addTextObject('(' + d.driveLetter + ':)', 'Segoe UI', 11, clr, 50, y + 5);
			}
			
			y += 48;
		}
			f=null;
			u=null;
			m=null;
			o=null;
			d=null;
			r=null;
	}
	if (y < 57) y = 57;
	canvas.style.height = y;
	document.body.style.posHeight = y;
	y=null;
}

function initDrives()
{
	var d = System.Gadget.Settings.read("drives");
	if (d.length == 0) d = 'C';
	
	drives = new Array(d.length);
	for(var i = 0; i < drives.length; i++)
	{
		drives[i] = System.Shell.drive(d.charAt(i));
	}
	
	showDrives();
	
	window.setTimeout(initDrives, 5000);
}